Index: /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 916)
+++ /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 917)
@@ -4540,36 +4540,37 @@
   printf("\n");
 #if SVC_EXTENSION  
-  printf("Total number of layers        : %d\n", m_numLayers       );
-  printf("Multiview                     : %d\n", m_scalabilityMask[VIEW_ORDER_INDEX] );
-  printf("Scalable                      : %d\n", m_scalabilityMask[SCALABILITY_ID] );
+  printf("Total number of layers            : %d\n", m_numLayers       );
+  printf("Multiview                         : %d\n", m_scalabilityMask[VIEW_ORDER_INDEX] );
+  printf("Scalable                          : %d\n", m_scalabilityMask[SCALABILITY_ID] );
 #if AVC_BASE
 #if VPS_AVC_BL_FLAG_REMOVAL
-  printf("Base layer                    : %s\n", m_nonHEVCBaseLayerFlag ? "Non-HEVC" : "HEVC");
-#else
-  printf("Base layer                    : %s\n", m_avcBaseLayerFlag ? "AVC" : "HEVC");
+  printf("Base layer                        : %s\n", m_nonHEVCBaseLayerFlag ? "Non-HEVC" : "HEVC");
+#else
+  printf("Base layer                        : %s\n", m_avcBaseLayerFlag ? "AVC" : "HEVC");
 #endif
 #endif
 #if AUXILIARY_PICTURES
-  printf("Auxiliary pictures            : %d\n", m_scalabilityMask[AUX_ID] );
+  printf("Auxiliary pictures                : %d\n", m_scalabilityMask[AUX_ID] );
 #endif
 #if M0040_ADAPTIVE_RESOLUTION_CHANGE
-  printf("Adaptive Resolution Change    : %d\n", m_adaptiveResolutionChange );
+  printf("Adaptive Resolution Change        : %d\n", m_adaptiveResolutionChange );
 #endif
 #if HIGHER_LAYER_IRAP_SKIP_FLAG
-  printf("Skip picture at ARC switch    : %d\n", m_skipPictureAtArcSwitch );
+  printf("Skip picture at ARC switch        : %d\n", m_skipPictureAtArcSwitch );
 #endif
 #if O0223_PICTURE_TYPES_ALIGN_FLAG
-  printf("Align picture type            : %d\n", m_crossLayerPictureTypeAlignFlag );
-#endif
-  printf("Cross layer IRAP alignment    : %d\n", m_crossLayerIrapAlignFlag );
+  printf("Align picture type                : %d\n", m_crossLayerPictureTypeAlignFlag );
+#endif
+  printf("Cross layer IRAP alignment        : %d\n", m_crossLayerIrapAlignFlag );
 #if P0068_CROSS_LAYER_ALIGNED_IDR_ONLY_FOR_IRAP_FLAG
-  printf("IDR only for IRAP             : %d\n", m_crossLayerAlignedIdrOnlyFlag );
+  printf("IDR only for IRAP                 : %d\n", m_crossLayerAlignedIdrOnlyFlag );
 #endif
 #if O0194_WEIGHTED_PREDICTION_CGS
-  printf("InterLayerWeightedPred        : %d\n", m_useInterLayerWeightedPred );
-#endif
-#if O0215_PHASE_ALIGNMENT
-  printf("Cross-layer sample alignment : %d\n", m_phaseAlignFlag);
-#endif
+  printf("InterLayerWeightedPred            : %d\n", m_useInterLayerWeightedPred );
+#endif
+#if O0215_PHASE_ALIGNMENT  
+  printf("Cross-layer sample alignment      : %d\n", m_phaseAlignFlag);
+#endif
+  printf("\n");
   for(UInt layer=0; layer<m_numLayers; layer++)
   {
@@ -4579,5 +4580,5 @@
   }
   printf("=== Common configuration settings === \n");
-  printf("Bitstream      File          : %s\n", m_pBitstreamFile      );
+  printf("Bitstream      File               : %s\n", m_pBitstreamFile      );
 #else //SVC_EXTENSION
   printf("Input          File               : %s\n", m_pchInputFile          );
Index: /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncLayerCfg.cpp
===================================================================
--- /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 916)
+++ /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 917)
@@ -300,18 +300,22 @@
 Void TAppEncLayerCfg::xPrintParameter()
 {
-  printf("Input File                    : %s\n", m_cInputFile.c_str()  );
-  printf("Reconstruction File           : %s\n", m_cReconFile.c_str()  );
+  printf("Input File                        : %s\n", m_cInputFile.c_str()  );
+  printf("Reconstruction File               : %s\n", m_cReconFile.c_str()  );
 #if REPN_FORMAT_IN_VPS
-  printf("Real     Format               : %dx%d %dHz\n", m_iSourceWidth - ( m_confWinLeft + m_confWinRight ) * TComSPS::getWinUnitX( m_chromaFormatIDC ), m_iSourceHeight - ( m_confWinTop + m_confWinBottom ) * TComSPS::getWinUnitY( m_chromaFormatIDC ), m_iFrameRate );
-#else
-  printf("Real     Format               : %dx%d %dHz\n", m_iSourceWidth - m_confWinLeft - m_confWinRight, m_iSourceHeight - m_confWinTop - m_confWinBottom, m_iFrameRate );
-#endif
-  printf("Internal Format               : %dx%d %dHz\n", m_iSourceWidth, m_iSourceHeight, m_iFrameRate );
+  printf("Real     Format                   : %dx%d %dHz\n", m_iSourceWidth - ( m_confWinLeft + m_confWinRight ) * TComSPS::getWinUnitX( m_chromaFormatIDC ), m_iSourceHeight - ( m_confWinTop + m_confWinBottom ) * TComSPS::getWinUnitY( m_chromaFormatIDC ), m_iFrameRate );
+#else
+  printf("Real     Format                   : %dx%d %dHz\n", m_iSourceWidth - m_confWinLeft - m_confWinRight, m_iSourceHeight - m_confWinTop - m_confWinBottom, m_iFrameRate );
+#endif
+  printf("Internal Format                   : %dx%d %dHz\n", m_iSourceWidth, m_iSourceHeight, m_iFrameRate );
 #if O0194_DIFFERENT_BITDEPTH_EL_BL
-  printf("Input bit depth               : (Y:%d, C:%d)\n", m_inputBitDepth[CHANNEL_TYPE_LUMA], m_inputBitDepth[CHANNEL_TYPE_CHROMA] );
-  printf("Internal bit depth            : (Y:%d, C:%d)\n", m_internalBitDepth[CHANNEL_TYPE_LUMA], m_internalBitDepth[CHANNEL_TYPE_CHROMA] );
-  printf("PCM sample bit depth          : (Y:%d, C:%d)\n", m_cAppEncCfg->getPCMInputBitDepthFlag() ? m_inputBitDepth[CHANNEL_TYPE_LUMA] : m_internalBitDepth[CHANNEL_TYPE_LUMA], m_cAppEncCfg->getPCMInputBitDepthFlag() ? m_inputBitDepth[CHANNEL_TYPE_CHROMA] : m_internalBitDepth[CHANNEL_TYPE_CHROMA] );
-#endif
+  printf("Input bit depth                   : (Y:%d, C:%d)\n", m_inputBitDepth[CHANNEL_TYPE_LUMA], m_inputBitDepth[CHANNEL_TYPE_CHROMA] );
+  printf("Internal bit depth                : (Y:%d, C:%d)\n", m_internalBitDepth[CHANNEL_TYPE_LUMA], m_internalBitDepth[CHANNEL_TYPE_CHROMA] );
+  printf("PCM sample bit depth              : (Y:%d, C:%d)\n", m_cAppEncCfg->getPCMInputBitDepthFlag() ? m_inputBitDepth[CHANNEL_TYPE_LUMA] : m_internalBitDepth[CHANNEL_TYPE_LUMA], m_cAppEncCfg->getPCMInputBitDepthFlag() ? m_inputBitDepth[CHANNEL_TYPE_CHROMA] : m_internalBitDepth[CHANNEL_TYPE_CHROMA] );
+#endif
+#if SVC_EXTENSION
+  std::cout << "Input ChromaFormatIDC             :";
+#else
   std::cout << std::setw(43) << "Input ChromaFormatIDC = ";
+#endif
   switch (m_InputChromaFormatIDC)
   {
@@ -326,5 +330,9 @@
   std::cout << std::endl;
 
+#if SVC_EXTENSION
+  std::cout << "Output (internal) ChromaFormatIDC :";
+#else
   std::cout << std::setw(43) << "Output (internal) ChromaFormatIDC = ";
+#endif
   switch (m_chromaFormatIDC)
   {
@@ -339,26 +347,27 @@
   std::cout << "\n" << std::endl;
 #if LAYER_CTB
-  printf("CU size / depth               : %d / %d\n", m_uiMaxCUWidth, m_uiMaxCUDepth );
-  printf("RQT trans. size (min / max)   : %d / %d\n", 1 << m_uiQuadtreeTULog2MinSize, 1 << m_uiQuadtreeTULog2MaxSize );
-  printf("Max RQT depth inter           : %d\n", m_uiQuadtreeTUMaxDepthInter);
-  printf("Max RQT depth intra           : %d\n", m_uiQuadtreeTUMaxDepthIntra);
-#endif
-  printf("QP                            : %5.2f\n", m_fQP );
-  printf("Intra period                  : %d\n", m_iIntraPeriod );
-#if RC_SHVC_HARMONIZATION
-  printf("RateControl                   : %d\n", m_RCEnableRateControl );
+  printf("CU size / depth                   : %d / %d\n", m_uiMaxCUWidth, m_uiMaxCUDepth );
+  printf("RQT trans. size (min / max)       : %d / %d\n", 1 << m_uiQuadtreeTULog2MinSize, 1 << m_uiQuadtreeTULog2MaxSize );
+  printf("Max RQT depth inter               : %d\n", m_uiQuadtreeTUMaxDepthInter);
+  printf("Max RQT depth intra               : %d\n", m_uiQuadtreeTUMaxDepthIntra);
+#endif
+  printf("QP                                : %5.2f\n", m_fQP );
+  printf("Intra period                      : %d\n", m_iIntraPeriod );
+#if RC_SHVC_HARMONIZATION                    
+  printf("RateControl                       : %d\n", m_RCEnableRateControl );
   if(m_RCEnableRateControl)
   {
-    printf("TargetBitrate                 : %d\n", m_RCTargetBitrate );
-    printf("KeepHierarchicalBit           : %d\n", m_RCKeepHierarchicalBit );
-    printf("LCULevelRC                    : %d\n", m_RCLCULevelRC );
-    printf("UseLCUSeparateModel           : %d\n", m_RCUseLCUSeparateModel );
-    printf("InitialQP                     : %d\n", m_RCInitialQP );
-    printf("ForceIntraQP                  : %d\n", m_RCForceIntraQP );
-  }
-#endif
-  printf("WaveFrontSynchro:%d WaveFrontSubstreams:%d", m_waveFrontSynchro, m_iWaveFrontSubstreams);
+    printf("TargetBitrate                     : %d\n", m_RCTargetBitrate );
+    printf("KeepHierarchicalBit               : %d\n", m_RCKeepHierarchicalBit );
+    printf("LCULevelRC                        : %d\n", m_RCLCULevelRC );
+    printf("UseLCUSeparateModel               : %d\n", m_RCUseLCUSeparateModel );
+    printf("InitialQP                         : %d\n", m_RCInitialQP );
+    printf("ForceIntraQP                      : %d\n", m_RCForceIntraQP );
+  }
+#endif
+  printf("WaveFrontSynchro                  : %d\n", m_waveFrontSynchro);
+  printf("WaveFrontSubstreams               : %d\n", m_iWaveFrontSubstreams);
 #if LAYER_CTB
-  printf("PCM:%d ", (m_cAppEncCfg->getUsePCM() && (1<<m_cAppEncCfg->getPCMLog2MinSize()) <= m_uiMaxCUWidth)? 1 : 0);
+  printf("PCM                               : %d ", (m_cAppEncCfg->getUsePCM() && (1<<m_cAppEncCfg->getPCMLog2MinSize()) <= m_uiMaxCUWidth)? 1 : 0);
 #endif
 }
Index: /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncTop.cpp	(revision 916)
+++ /branches/SHM-upgrade/source/App/TAppEncoder/TAppEncTop.cpp	(revision 917)
@@ -2321,5 +2321,4 @@
   //-- all
   printf( "\n\nSUMMARY --------------------------------------------------------\n" );
-  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
   for(layer = 0; layer < m_numLayers; layer++)
   {
@@ -2328,5 +2327,4 @@
 
   printf( "\n\nI Slices--------------------------------------------------------\n" );
-  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
   for(layer = 0; layer < m_numLayers; layer++)
   {
@@ -2335,5 +2333,4 @@
 
   printf( "\n\nP Slices--------------------------------------------------------\n" );
-  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
   for(layer = 0; layer < m_numLayers; layer++)
   {
@@ -2342,5 +2339,4 @@
 
   printf( "\n\nB Slices--------------------------------------------------------\n" );
-  printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
   for(layer = 0; layer < m_numLayers; layer++)
   {
@@ -2365,4 +2361,7 @@
     }
   }
+
+  printf("\n");
+  //printf("\nRVM: %.3lf\n" , xCalculateRVM());
 }
 
Index: /branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h	(revision 916)
+++ /branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h	(revision 917)
@@ -228,5 +228,4 @@
 
 #define Q0195_REP_FORMAT_CLEANUP         1      ///< JCTVC-Q0195: restructureing of rep_format() signaling
-#define REP_FORMAT_FIX                   1      ///< update_rep_format_flag should be inferred to be equal to 0
 
 #define R0156_CONF_WINDOW_IN_REP_FORMAT  O0096_REP_FORMAT_INDEX ///< JCTVC-R0156: add conformance window cropping offsets to rep_format()
@@ -296,6 +295,4 @@
 };
 
-#define WPP_FIX                          1
-
 /// normative encoder constraints --------
 #define MFM_ENCCONSTRAINT                1      ///< JCTVC-O0216: Encoder constraint for motion field mapping
@@ -313,5 +310,4 @@
 
 /// SEI messages -------------------------
-#define P0050_KNEE_FUNCTION_SEI          1      ///< JCTVC-P0050: Knee function SEI
 #define SUB_BITSTREAM_PROPERTY_SEI       1      ///< JCTVC-P0204: Sub-bitstream property SEI message
 #if SUB_BITSTREAM_PROPERTY_SEI
Index: /branches/SHM-upgrade/source/Lib/TLibEncoder/TEncAnalyze.h
===================================================================
--- /branches/SHM-upgrade/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 916)
+++ /branches/SHM-upgrade/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 917)
@@ -165,4 +165,8 @@
         if (printMSEBasedSNR)
         {
+#if SVC_EXTENSION
+          if( layer == 0 )
+          {
+#endif
           printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR" );
 
@@ -171,5 +175,13 @@
 
           //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+#if SVC_EXTENSION
+          }
+
+          printf( "Average:  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf",
+                 layer,
+
+#else
           printf( "Average: \t %8d    %c "          "%12.4lf  "    "%8.4lf",
+#endif
                  getNumPic(), cDelim,
                  getBits() * dScale,
@@ -182,5 +194,10 @@
           else printf("\n");
 
+#if SVC_EXTENSION
+          printf( "From MSE:  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf\n",
+                 layer,
+#else
           printf( "From MSE:\t %8d    %c "          "%12.4lf  "    "%8.4lf\n",
+#endif
                  getNumPic(), cDelim,
                  getBits() * dScale,
@@ -196,5 +213,5 @@
           //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
 #if SVC_EXTENSION
-          printf( "    L%d\t %8d    %c "          "%12.4lf  "    "%8.4lf",
+          printf( "  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf",
                  layer,
 #else
@@ -223,4 +240,8 @@
           if (printMSEBasedSNR)
           {
+#if SVC_EXTENSION
+            if( layer == 0 )
+            {
+#endif
             printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
 
@@ -229,5 +250,11 @@
 
             //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+#if SVC_EXTENSION
+            }
+            printf( "Average:  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+                   layer,
+#else
             printf( "Average: \t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+#endif
                    getNumPic(), cDelim,
                    getBits() * dScale,
@@ -247,5 +274,10 @@
             else printf("\n");
 
+#if SVC_EXTENSION
+            printf( "From MSE:  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf\n",
+                   layer,
+#else
             printf( "From MSE:\t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf\n",
+#endif
                    getNumPic(), cDelim,
                    getBits() * dScale,
@@ -257,4 +289,8 @@
           else
           {
+#if SVC_EXTENSION
+            if( layer == 0 )
+            {
+#endif
             printf( "\tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
             
@@ -263,5 +299,11 @@
 
             //printf( "\t------------ "  " ----------"   " -------- "  " -------- "  " --------\n" );
+#if SVC_EXTENSION
+            }
+            printf( "  L%d \t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+                   layer,
+#else
             printf( "\t %8d    %c "          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf  "   "%8.4lf",
+#endif
                    getNumPic(), cDelim,
                    getBits() * dScale,