Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/ContextTables.h	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/ContextTables.h	(revision 921)
@@ -430,11 +430,20 @@
 
 #if H_3D_DBBP
+#if MTK_DBBP_SIGNALING_H0094
 static const UChar INIT_DBBP_FLAG[3][DBBP_NUM_FLAG_CTX] =
 {
-  { CNU },
-  { CNU },
-  { CNU },
-};
-#endif
-
-#endif
+  { 161 },
+  { 161 },
+  { 161 },
+};
+#else
+static const UChar INIT_DBBP_FLAG[3][DBBP_NUM_FLAG_CTX] =
+{
+  { CNU },
+  { CNU },
+  { CNU },
+};
+#endif
+#endif
+
+#endif
Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h	(revision 921)
@@ -301,4 +301,5 @@
 #define RWTH_DBBP_NO_SPU_H0057                 1
 #define SEC_DBBP_FILTERING_H0104               1
+#define MTK_DBBP_SIGNALING_H0094               1    
 #endif
 
Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 921)
@@ -139,5 +139,10 @@
   
 #if H_3D_DBBP
+
+#if MTK_DBBP_SIGNALING_H0094
+  if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) )
+#else
   if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && pcCU->getPartitionSize(uiAbsPartIdx) == RWTH_DBBP_PACK_MODE )
+#endif
   {
     decodeDBBPFlag(pcCU, uiAbsPartIdx, uiDepth);
@@ -145,6 +150,8 @@
     if( pcCU->getDBBPFlag(uiAbsPartIdx) )
     {
+#if !MTK_DBBP_SIGNALING_H0094
       AOF( pcCU->getPartitionSize(uiAbsPartIdx) == RWTH_DBBP_PACK_MODE );
-      
+#endif
+
       // get collocated depth block
       UInt uiDepthStride = 0;
Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 921)
@@ -2141,8 +2141,12 @@
 Void TDecSbac::parseDBBPFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
+#if !MTK_DBBP_SIGNALING_H0094
   PartSize ePartSize = pcCU->getPartitionSize( uiAbsPartIdx );
+#endif
   AOF( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) );
   AOF( !pcCU->getSlice()->getIsDepth() );
+#if !MTK_DBBP_SIGNALING_H0094
   AOF( ePartSize == RWTH_DBBP_PACK_MODE );
+#endif
   
   UInt uiSymbol = 0;
Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 921)
@@ -246,5 +246,10 @@
   
 #if H_3D_DBBP
+
+#if MTK_DBBP_SIGNALING_H0094
+  if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) )
+#else
   if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && pcCU->getPartitionSize(uiAbsPartIdx) == RWTH_DBBP_PACK_MODE )
+#endif
   {
     encodeDBBPFlag(pcCU, uiAbsPartIdx, bRD);
@@ -252,5 +257,7 @@
     if( pcCU->getDBBPFlag(uiAbsPartIdx) )
     {
+#if !MTK_DBBP_SIGNALING_H0094
       AOF( pcCU->getPartitionSize(uiAbsPartIdx) == RWTH_DBBP_PACK_MODE );
+#endif
       // restore virtual partition size for DBBP blocks
       pcCU->setPartSizeSubParts(eVirtualPartSize, uiAbsPartIdx, uiDepth);
Index: branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 920)
+++ branches/HTM-10.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 921)
@@ -2356,6 +2356,8 @@
 Void TEncSbac::codeDBBPFlag( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
+#if !MTK_DBBP_SIGNALING_H0094
   PartSize ePartSize = pcCU->getPartitionSize( uiAbsPartIdx );
   AOF( ePartSize == RWTH_DBBP_PACK_MODE );
+#endif
   AOF( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) );
   AOF( !pcCU->getSlice()->getIsDepth() );